︠4067c573-85ef-42b2-a7d6-1fd1dd469b58︠
#what is the probability that at least one pair of n students has the same birthday?
#how many students do you need in order for the probability to be at least 0.5?

︡1c36cbf8-97df-4a0c-96f0-eb15c4d3195d︡{"done":true}︡
︠819bed14-3dae-41db-b4da-5ec397e940fds︠
#given n, we need to guess n random birthdays
#(we'll assume that birthdays are uniformly distributed - not true in real life)
#instead of guessing jan.1, nov. 14, etc, we can just use numbers 1 to 365
#can use randint
randint(1,365)
︡a4bfe3aa-6d1b-4e78-99b3-b568c6dba1e3︡{"stdout":"22\n"}︡{"done":true}︡
︠4b369314-83bd-4212-bc36-96285ad59740s︠
n = 5
guess = [randint(1,365) for i in [1..n]]
︡9e522208-a0a0-4cdb-a613-dd1a1dc708b8︡{"done":true}︡
︠1f5f2b2c-e33f-4ffb-b181-019e605c9c27s︠
range(5)
︡5f09ce24-a3f3-45a0-aa40-e707a0977915︡{"stdout":"[0, 1, 2, 3, 4]\n"}︡{"done":true}︡
︠5e463269-f8d9-46df-b799-e6b6ceaa7e3as︠
range(2,6)
︡5c048c66-18ef-416d-bb70-06821064e8b4︡{"stdout":"[2, 3, 4, 5]\n"}︡{"done":true}︡
︠339c797c-2769-4251-8af5-7844d00dd3d3s︠
guess
︡e46757a2-ea09-4e7f-bae3-c6058a1c5455︡{"stdout":"[244, 233, 226, 66, 354]\n"}︡{"done":true}︡
︠9e87d9cf-d4a1-4519-9dda-38ac6251a1a7s︠
#after we make a guess, we need to check is there's a pair of numbers that's the same
for i in range(n):
    for j in range(n):
        if j > i and guess[i] == guess[j]:
            print "Bingo!"
︡619c656a-0e8f-4a95-a3e6-a2e9c4d39483︡{"done":true}︡
︠67a66cba-cb04-477d-804f-202acf2624ces︠
#repeat this experiment *many* (how many?) times and collect data
#then the empirical probability of a pair of n studnets having the same birthday
#*is* the (number of successes) / (number of experiments)
︡57449852-243c-4598-a0c8-988490c71210︡{"done":true}︡
︠0b7baa32-e89e-4471-b870-99f75d4188abs︠
L=[5,6,7,6]
S=Set(L)
L
S
#if a list on integers has a pair that the same,
#the corresponding set will have fewer elements
len(L)
len(S)
︡165533a5-9358-4b16-84bc-4cb074abb2c0︡{"stdout":"[5, 6, 7, 6]\n"}︡{"stdout":"{5, 6, 7}\n"}︡{"stdout":"4\n"}︡{"stdout":"3\n"}︡{"done":true}︡
︠ca37750a-fc2f-49a7-86cb-0cf89bb75138s︠
n = 23
#guess of n random birthdays
birthdays = [randint(1,365) for i in [1..n]]
birthdays
#test if there's a piar that the same by testing if the Set of birthdays is smaller than the List of birthdays
if len(Set(birthdays)) < len(birthdays):
    print "Bingo!"
︡704bf503-cad3-4723-b485-d4c84504a5d7︡{"stdout":"[23, 113, 3, 160, 179, 285, 228, 119, 59, 34, 197, 171, 265, 349, 311, 54, 126, 165, 149, 102, 155, 23, 101]\n"}︡{"stdout":"Bingo!\n"}︡{"done":true}︡
︠8362b362-05d9-4948-b1c3-3c99e984599es︠
def birthday_test(n):
    successes = 0
    for i in [1..1000]:
        birthdays = [randint(1,365) for i in [1..n]]
        if len(Set(birthdays)) < len(birthdays):
            successes = successes + 1
    return successes/1000
︡86080a1d-c061-4929-9465-922bc4f3861d︡{"done":true}︡
︠8960c101-209c-43c5-8c2e-92524e314771s︠
birthday_test(5)
︡486612f5-6304-461a-9bdd-c23627152cf4︡{"stdout":"0.0210000000000000"}︡{"stdout":"\n"}︡{"done":true}︡
︠f0aa6ae1-62d8-4a9c-82ea-c4277b28e32ds︠
birthday_test(23)
︡0f00861b-8381-42a7-972b-0db87f94d843︡{"stdout":"0.505000000000000"}︡{"stdout":"\n"}︡{"done":true}︡
︠660f3d45-1c72-4421-997f-600db3c4fc60s︠
birthday_test(77)
︡70c77037-7eab-4576-800f-0c00695f2392︡{"stdout":"1.00000000000000"}︡{"stdout":"\n"}︡{"done":true}︡
︠e8b563d4-193a-4e41-aada-a6c167f68365︠
︡a5f6501f-1148-41e3-b313-ccae54a8ef6c︡
︠2d8fdbe9-e2a5-4f47-9383-ab12d54b549cs︠
birthday_test(366)
︡5e158fc4-d698-47c5-ab04-8fc3563558d0︡{"stdout":"1.00000000000000"}︡{"stdout":"\n"}︡{"done":true}︡
︠03d43f29-c3fc-4766-9147-0383d74657dbs︠
birthday_test(1)
︡c4d90af9-63ea-4ff3-8ff6-26c2578af8e2︡{"stdout":"0.000000000000000"}︡{"stdout":"\n"}︡{"done":true}︡
︠737b935c-c381-4ca0-9890-d1ac9634777es︠
#is there is problem? it can't be probability  effectively 1 for only 77 stdents, can it?!?!?!
#can't use plot as our function is only defined for positive integers
#so let's get 365 data points and use scatter plot
data = [(x, birthday_test(x)) for x in [1..366]]
︡b7199b17-6d9b-4c93-a1de-101ebf9a3d0d︡{"stderr":"Error in lines 1-1\n"}︡{"stderr":"Traceback (most recent call last):\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 982, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"\", line 4, in birthday_test\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/sage/misc/prandom.py\", line 125, in randint\n    return _pyrand().randint(a, b)\n  File \"/projects/sage/sage-7.5/local/lib/python/random.py\", line 242, in randint\n    return self.randrange(a, b+1)\n  File \"src/cysignals/signals.pyx\", line 252, in cysignals.signals.python_check_interrupt (build/src/cysignals/signals.c:2854)\n  File \"src/cysignals/signals.pyx\", line 97, in cysignals.signals.sig_raise_exception (build/src/cysignals/signals.c:1303)\nKeyboardInterrupt\n"}︡{"done":true}︡
︠5e43fce7-41f1-401b-9ac8-cd63efeafff8s︠
for i in [1..365]:
    print i, birthday_test(i)
︡c2866bbe-a026-459b-980a-70330a7522fc︡{"stdout":"1 "}︡{"stdout":"0.000000000000000\n2 "}︡{"stdout":"0.00400000000000000\n3 "}︡{"stdout":"0.0120000000000000\n4 "}︡{"stdout":"0.0200000000000000\n5 "}︡{"stdout":"0.0260000000000000\n6 "}︡{"stdout":"0.0410000000000000\n7 "}︡{"stdout":"0.0580000000000000\n8 "}︡{"stdout":"0.0860000000000000\n9 "}︡{"stdout":"0.104000000000000\n10 "}︡{"stdout":"0.127000000000000\n11 "}︡{"stdout":"0.136000000000000\n12 "}︡{"stdout":"0.191000000000000\n13 "}︡{"stdout":"0.179000000000000\n14 "}︡{"stdout":"0.244000000000000\n15 "}︡{"stdout":"0.255000000000000\n16 "}︡{"stdout":"0.275000000000000\n17 "}︡{"stdout":"0.308000000000000\n18 "}︡{"stdout":"0.343000000000000\n19 "}︡{"stdout":"0.377000000000000\n20 "}︡{"stdout":"0.412000000000000\n21 "}︡{"stdout":"0.436000000000000\n22 "}︡{"stdout":"0.488000000000000\n23 "}︡{"stdout":"0.524000000000000\n24 "}︡{"stdout":"0.544000000000000\n25 "}︡{"stdout":"0.562000000000000\n26 "}︡{"stdout":"0.598000000000000\n27 "}︡{"stdout":"0.625000000000000\n28 "}︡{"stdout":"0.662000000000000\n29 "}︡{"stdout":"0.706000000000000\n30 "}︡{"stdout":"0.693000000000000\n31 "}︡{"stdout":"0.747000000000000\n32 "}︡{"stdout":"0.749000000000000\n33 "}︡{"stdout":"0.774000000000000\n34 "}︡{"stdout":"0.798000000000000\n35 "}︡{"stdout":"0.814000000000000\n36 "}︡{"stdout":"0.836000000000000\n37 "}︡{"stdout":"0.849000000000000\n38 "}︡{"stdout":"0.859000000000000\n39 "}︡{"stdout":"0.880000000000000\n40 "}︡{"stdout":"0.890000000000000\n41 "}︡{"stdout":"0.891000000000000\n42 "}︡{"stdout":"0.927000000000000\n43 "}︡{"stdout":"0.927000000000000\n44 "}︡{"stdout":"0.937000000000000\n45 "}︡{"stdout":"0.942000000000000\n46 "}︡{"stdout":"0.957000000000000\n47 "}︡{"stdout":"0.962000000000000\n48 "}︡{"stdout":"0.970000000000000\n49 "}︡{"stdout":"0.964000000000000\n50 "}︡{"stdout":"0.962000000000000\n51 "}︡{"stdout":"0.979000000000000\n52 "}︡{"stdout":"0.979000000000000\n53 "}︡{"stdout":"0.981000000000000\n54 "}︡{"stdout":"0.986000000000000\n55 "}︡{"stdout":"0.990000000000000\n56 "}︡{"stdout":"0.990000000000000\n57 "}︡{"stdout":"0.990000000000000\n58 "}︡{"stdout":"0.995000000000000\n59 "}︡{"stdout":"0.997000000000000\n60 "}︡{"stdout":"0.996000000000000\n61 "}︡{"stdout":"0.995000000000000\n62 "}︡{"stdout":"0.997000000000000\n63 "}︡{"stdout":"0.995000000000000\n64 "}︡{"stdout":"0.998000000000000\n65 "}︡{"stdout":"0.998000000000000\n66 "}︡{"stdout":"0.998000000000000\n67 "}︡{"stdout":"0.999000000000000\n68 "}︡{"stdout":"1.00000000000000\n69 "}︡{"stdout":"0.997000000000000\n70 "}︡{"stdout":"0.997000000000000\n71 "}︡{"stdout":"1.00000000000000\n72 "}︡{"stdout":"1.00000000000000\n73 "}︡{"stdout":"1.00000000000000\n74 "}︡{"stdout":"0.999000000000000\n75 "}︡{"stdout":"1.00000000000000\n76 "}︡{"stdout":"1.00000000000000\n77 "}︡{"stdout":"0.999000000000000\n78 "}︡{"stdout":"1.00000000000000\n79 "}︡{"stdout":"1.00000000000000\n80 "}︡{"stdout":"1.00000000000000\n81 "}︡{"stdout":"1.00000000000000\n82 "}︡{"stdout":"1.00000000000000\n83 "}︡{"stdout":"1.00000000000000\n84 "}︡{"stdout":"1.00000000000000\n85 "}︡{"stdout":"1.00000000000000\n86 "}︡{"stdout":"1.00000000000000\n87 "}︡{"stdout":"1.00000000000000\n88 "}︡{"stdout":"1.00000000000000\n89 "}︡{"stdout":"1.00000000000000\n90 "}︡{"stdout":"1.00000000000000\n91 "}︡{"stdout":"1.00000000000000\n92 "}︡{"stdout":"1.00000000000000\n93 "}︡{"stdout":"1.00000000000000\n94 "}︡{"stdout":"1.00000000000000\n95 "}︡{"stdout":"1.00000000000000\n96 "}︡{"stdout":"1.00000000000000\n97 "}︡{"stdout":"1.00000000000000\n98 "}︡{"stdout":"1.00000000000000\n99 "}︡{"stdout":"1.00000000000000\n100 "}︡{"stdout":"1.00000000000000\n101 "}︡{"stdout":"1.00000000000000\n102 "}︡{"stdout":"1.00000000000000\n103 "}︡{"stdout":"1.00000000000000\n104 "}︡{"stdout":"1.00000000000000\n105 "}︡{"stdout":"1.00000000000000\n106 "}︡{"stdout":"1.00000000000000\n107 "}︡{"stdout":"1.00000000000000\n108 "}︡{"stdout":"1.00000000000000\n109 "}︡{"stdout":"1.00000000000000\n110 "}︡{"stdout":"1.00000000000000\n111 "}︡{"stdout":"1.00000000000000\n112 "}︡{"stdout":"1.00000000000000\n113 "}︡{"stdout":"1.00000000000000\n114 "}︡{"stdout":"1.00000000000000\n115 "}︡{"stdout":"1.00000000000000\n116 "}︡{"stdout":"1.00000000000000\n117 "}︡{"stdout":"1.00000000000000\n118 "}︡{"stdout":"1.00000000000000\n119 "}︡{"stdout":"1.00000000000000\n120 "}︡{"stdout":"1.00000000000000\n121 "}︡{"stdout":"1.00000000000000\n122 "}︡{"stdout":"1.00000000000000\n123 "}︡{"stdout":"1.00000000000000\n124 "}︡{"stdout":"1.00000000000000\n125 "}︡{"stdout":"1.00000000000000\n126 "}︡{"stdout":"1.00000000000000\n127 "}︡{"stdout":"1.00000000000000\n128 "}︡{"stdout":"1.00000000000000\n129 "}︡{"stdout":"1.00000000000000\n130 "}︡{"stdout":"1.00000000000000\n131 "}︡{"stdout":"1.00000000000000\n132 "}︡{"stdout":"1.00000000000000\n133 "}︡{"stdout":"1.00000000000000\n134 "}︡{"stdout":"1.00000000000000\n135 "}︡{"stdout":"1.00000000000000\n136 "}︡{"stdout":"1.00000000000000\n137 "}︡{"stdout":"1.00000000000000\n138 "}︡{"stdout":"1.00000000000000\n139 "}︡{"stdout":"1.00000000000000\n140 "}︡{"stdout":"1.00000000000000\n141 "}︡{"stdout":"1.00000000000000\n142 "}︡{"stdout":"1.00000000000000\n143 "}︡{"stdout":"1.00000000000000\n144 "}︡{"stdout":"1.00000000000000\n145 "}︡{"stdout":"1.00000000000000\n146 "}︡{"stdout":"1.00000000000000\n147 "}︡{"stdout":"1.00000000000000\n148 "}︡{"stdout":"1.00000000000000\n149 "}︡{"stdout":"1.00000000000000\n150 "}︡{"stdout":"1.00000000000000\n151 "}︡{"stdout":"1.00000000000000\n152 "}︡{"stdout":"1.00000000000000\n153 "}︡{"stdout":"1.00000000000000\n154 "}︡{"stdout":"1.00000000000000\n155 "}︡{"stdout":"1.00000000000000\n156 "}︡{"stdout":"1.00000000000000\n157 "}︡{"stdout":"1.00000000000000\n158 "}︡{"stdout":"1.00000000000000\n159 "}︡{"stdout":"1.00000000000000\n160 "}︡{"stdout":"1.00000000000000\n161 "}︡{"stdout":"1.00000000000000\n162 "}︡{"stdout":"1.00000000000000\n163 "}︡{"stdout":"1.00000000000000\n164 "}︡{"stdout":"1.00000000000000\n165 "}︡{"stdout":"1.00000000000000\n166 "}︡{"stdout":"1.00000000000000\n167 "}︡{"stdout":"1.00000000000000\n168 "}︡{"stdout":"1.00000000000000\n169 "}︡{"stdout":"1.00000000000000\n170 "}︡{"stdout":"1.00000000000000\n171 "}︡{"stdout":"1.00000000000000\n172 "}︡{"stdout":"1.00000000000000\n173 "}︡{"stdout":"1.00000000000000\n174 "}︡{"stdout":"1.00000000000000\n175 "}︡{"stdout":"1.00000000000000\n176 "}︡{"stdout":"1.00000000000000\n177 "}︡{"stdout":"1.00000000000000\n178 "}︡{"stdout":"1.00000000000000\n179 "}︡{"stdout":"1.00000000000000\n180 "}︡{"stdout":"1.00000000000000\n181 "}︡{"stdout":"1.00000000000000\n182 "}︡{"stdout":"1.00000000000000\n183 "}︡{"stdout":"1.00000000000000\n184 "}︡{"stdout":"1.00000000000000\n185 "}︡{"stdout":"1.00000000000000\n186 "}︡{"stdout":"1.00000000000000\n187 "}︡{"stdout":"1.00000000000000\n188 "}︡{"stdout":"1.00000000000000\n189 "}︡{"stdout":"1.00000000000000\n190 "}︡{"stdout":"1.00000000000000\n191"}︡{"stderr":"Error in lines 1-2\n"}︡{"stderr":"Traceback (most recent call last):\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 982, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 2, in <module>\n  File \"\", line 4, in birthday_test\n  File \"src/cysignals/signals.pyx\", line 252, in cysignals.signals.python_check_interrupt (build/src/cysignals/signals.c:2854)\n  File \"src/cysignals/signals.pyx\", line 97, in cysignals.signals.sig_raise_exception (build/src/cysignals/signals.c:1303)\nKeyboardInterrupt\n"}︡{"done":true}︡
︠14b2226b-e380-4ee0-a9aa-47f678ab0bb4so︠
data = []
for i in [1..365]:
    result = birthday_test(i)
    print i, result
    data.append((i,result))
︡b3fbc91e-08da-492a-b587-a2a67fb737e3︡{"stdout":"1"}︡{"stdout":" 0\n2"}︡{"stdout":" 1/200\n3"}︡{"stdout":" 1/125\n4"}︡{"stdout":" 3/200\n5"}︡{"stdout":" 1/40\n6"}︡{"stdout":" 43/1000\n7"}︡{"stdout":" 31/500\n8"}︡{"stdout":" 17/200\n9"}︡{"stdout":" 49/500\n10"}︡{"stdout":" 63/500\n11"}︡{"stdout":" 79/500\n12"}︡{"stdout":" 177/1000\n13"}︡{"stdout":" 51/250\n14"}︡{"stdout":" 26/125\n15"}︡{"stdout":" 267/1000\n16"}︡{"stdout":" 283/1000\n17"}︡{"stdout":" 327/1000\n18"}︡{"stdout":" 349/1000\n19"}︡{"stdout":" 183/500\n20"}︡{"stdout":" 77/200\n21"}︡{"stdout":" 467/1000\n22"}︡{"stdout":" 477/1000\n23"}︡{"stdout":" 101/200\n24"}︡{"stdout":" 68/125\n25"}︡{"stdout":" 559/1000\n26"}︡{"stdout":" 591/1000\n27"}︡{"stdout":" 79/125\n28"}︡{"stdout":" 669/1000\n29"}︡{"stdout":" 339/500\n30"}︡{"stdout":" 86/125\n31"}︡{"stdout":" 729/1000\n32"}︡{"stdout":" 747/1000\n33"}︡{"stdout":" 781/1000\n34"}︡{"stdout":" 383/500\n35"}︡{"stdout":" 807/1000\n36"}︡{"stdout":" 103/125\n37"}︡{"stdout":" 847/1000\n38"}︡{"stdout":" 861/1000\n39"}︡{"stdout":" 437/500\n40"}︡{"stdout":" 177/200\n41"}︡{"stdout":" 901/1000\n42"}︡{"stdout":" 23/25\n43"}︡{"stdout":" 116/125\n44"}︡{"stdout":" 457/500\n45"}︡{"stdout":" 116/125\n46"}︡{"stdout":" 951/1000\n47"}︡{"stdout":" 947/1000\n48"}︡{"stdout":" 193/200\n49"}︡{"stdout":" 969/1000\n50"}︡{"stdout":" 969/1000\n51"}︡{"stdout":" 977/1000\n52"}︡{"stdout":" 487/500\n53"}︡{"stdout":" 493/500\n54"}︡{"stdout":" 493/500\n55"}︡{"stdout":" 99/100\n56"}︡{"stdout":" 197/200\n57"}︡{"stdout":" 989/1000\n58"}︡{"stdout":" 124/125\n59"}︡{"stdout":" 124/125\n60"}︡{"stdout":" 124/125\n61"}︡{"stdout":" 993/1000\n62"}︡{"stdout":" 1\n63"}︡{"stdout":" 997/1000\n64"}︡{"stdout":" 997/1000\n65"}︡{"stdout":" 249/250\n66"}︡{"stdout":" 499/500\n67"}︡{"stdout":" 1\n68"}︡{"stdout":" 499/500\n69"}︡{"stdout":" 1\n70"}︡{"stdout":" 999/1000\n71"}︡{"stdout":" 499/500\n72"}︡{"stdout":" 1\n73"}︡{"stdout":" 1\n74"}︡{"stdout":" 499/500\n75"}︡{"stdout":" 1\n76"}︡{"stdout":" 1\n77"}︡{"stdout":" 1\n78"}︡{"stdout":" 1\n79"}︡{"stdout":" 1\n80"}︡{"stdout":" 1\n81"}︡{"stdout":" 1\n82"}︡{"stdout":" 1\n83"}︡{"stdout":" 1\n84"}︡{"stdout":" 1\n85"}︡{"stdout":" 1\n86"}︡{"stdout":" 1\n87"}︡{"stdout":" 1\n88"}︡{"stdout":" 1\n89"}︡{"stdout":" 1\n90"}︡{"stdout":" 1\n91"}︡{"stdout":" 1\n92"}︡{"stdout":" 1\n93"}︡{"stdout":" 1\n94"}︡{"stdout":" 1\n95"}︡{"stdout":" 1\n96"}︡{"stdout":" 1\n97"}︡{"stdout":" 1\n98"}︡{"stdout":" 1\n99"}︡{"stdout":" 1\n100"}︡{"stdout":" 1\n101"}︡{"stdout":" 1\n102"}︡{"stdout":" 1\n103"}︡{"stdout":" 1\n104"}︡{"stdout":" 1\n105"}︡{"stdout":" 1\n106"}︡{"stdout":" 1\n107"}︡{"stdout":" 1\n108"}︡{"stdout":" 1\n109"}︡{"stdout":" 1\n110"}︡{"stdout":" 1\n111"}︡{"stdout":" 1\n112"}︡{"stdout":" 1\n113"}︡{"stdout":" 1\n114"}︡{"stdout":" 1\n115"}︡{"stdout":" 1\n116"}︡{"stdout":" 1\n117"}︡{"stdout":" 1\n118"}︡{"stdout":" 1\n119"}︡{"stdout":" 1\n120"}︡{"stdout":" 1\n121"}︡{"stdout":" 1\n122"}︡{"stdout":" 1\n123"}︡{"stdout":" 1\n124"}︡{"stdout":" 1\n125"}︡{"stdout":" 1\n126"}︡{"stdout":" 1\n127"}︡{"stdout":" 1\n128"}︡{"stdout":" 1\n129"}︡{"stdout":" 1\n130"}︡{"stdout":" 1\n131"}︡{"stdout":" 1\n132"}︡{"stdout":" 1\n133"}︡{"stdout":" 1\n134"}︡{"stdout":" 1\n135"}︡{"stdout":" 1\n136"}︡{"stdout":" 1\n137"}︡{"stdout":" 1\n138"}︡{"stdout":" 1\n139"}︡{"stdout":" 1\n140"}︡{"stdout":" 1\n141"}︡{"stdout":" 1\n142"}︡{"stdout":" 1\n143"}︡{"stdout":" 1\n144"}︡{"stdout":" 1\n145"}︡{"stdout":" 1\n146"}︡{"stdout":" 1\n147"}︡{"stdout":" 1\n148"}︡{"stdout":" 1\n149"}︡{"stdout":" 1\n150"}︡{"stdout":" 1\n151"}︡{"stdout":" 1\n152"}︡{"stdout":" 1\n153"}︡{"stdout":" 1\n154"}︡{"stdout":" 1\n155"}︡{"stdout":" 1\n156"}︡{"stdout":" 1\n157"}︡{"stdout":" 1\n158"}︡{"stdout":" 1\n159"}︡{"stdout":" 1\n160"}︡{"stdout":" 1\n161"}︡{"stdout":" 1\n162"}︡{"stdout":" 1\n163"}︡{"stdout":" 1\n164"}︡{"stdout":" 1\n165"}︡{"stdout":" 1\n166"}︡{"stdout":" 1\n167"}︡{"stdout":" 1\n168"}︡{"stdout":" 1\n169"}︡{"stdout":" 1\n170"}︡{"stdout":" 1\n171"}︡{"stdout":" 1\n172"}︡{"stdout":" 1\n173"}︡{"stdout":" 1\n174"}︡{"stdout":" 1\n175"}︡{"stdout":" 1\n176"}︡{"stdout":" 1\n177"}︡{"stdout":" 1\n178"}︡{"stdout":" 1\n179"}︡{"stdout":" 1\n180"}︡{"stdout":" 1\n181"}︡{"stdout":" 1\n182"}︡{"stdout":" 1\n183"}︡{"stdout":" 1\n184"}︡{"stdout":" 1\n185"}︡{"stdout":" 1\n186"}︡{"stdout":" 1\n187"}︡{"stdout":" 1\n188"}︡{"stdout":" 1\n189"}︡{"stdout":" 1\n190"}︡{"stdout":" 1\n191"}︡{"stdout":" 1\n192"}︡{"stdout":" 1\n193"}︡{"stdout":" 1\n194"}︡{"stdout":" 1\n195"}︡{"stdout":" 1\n196"}︡{"stdout":" 1\n197"}︡{"stdout":" 1\n198"}︡{"stdout":" 1\n199"}︡{"stdout":" 1\n200"}︡{"stdout":" 1\n201"}︡{"stdout":" 1\n202"}︡{"stdout":" 1\n203"}︡{"stdout":" 1\n204"}︡{"stdout":" 1\n205"}︡{"stdout":" 1\n206"}︡{"stdout":" 1\n207"}︡{"stdout":" 1\n208"}︡{"stdout":" 1\n209"}︡{"stdout":" 1\n210"}︡{"stdout":" 1\n211"}︡{"stdout":" 1\n212"}︡{"stdout":" 1\n213"}︡{"stdout":" 1\n214"}︡{"stdout":" 1\n215"}︡{"stdout":" 1\n216"}︡{"stdout":" 1\n217"}︡{"stdout":" 1\n218"}︡{"stdout":" 1\n219"}︡{"stdout":" 1\n220"}︡{"stdout":" 1\n221"}︡{"stdout":" 1\n222"}︡{"stdout":" 1\n223"}︡{"stdout":" 1\n224"}︡{"stdout":" 1\n225"}︡{"stdout":" 1\n226"}︡{"stdout":" 1\n227"}︡{"stdout":" 1\n228"}︡{"stdout":" 1\n229"}︡{"stdout":" 1\n230"}︡{"stdout":" 1\n231"}︡{"stdout":" 1\n232"}︡{"stdout":" 1\n233"}︡{"stdout":" 1\n234"}︡{"stdout":" 1\n235"}︡{"stdout":" 1\n236"}︡{"stdout":" 1\n237"}︡{"stdout":" 1\n238"}︡{"stdout":" 1\n239"}︡{"stdout":" 1\n240"}︡{"stdout":" 1\n241"}︡{"stdout":" 1\n242"}︡{"stdout":" 1\n243"}︡{"stdout":" 1\n244"}︡{"stdout":" 1\n245"}︡{"stdout":" 1\n246"}︡{"stdout":" 1\n247"}︡{"stdout":" 1\n248"}︡{"stdout":" 1\n249"}︡{"stdout":" 1\n250"}︡{"stdout":" 1\n251"}︡{"stdout":" 1\n252"}︡{"stdout":" 1\n253"}︡{"stdout":" 1\n254"}︡{"stdout":" 1\n255"}︡{"stdout":" 1\n256"}︡{"done":true,"once":false,"stderr":"\nToo many output messages: 257 (at most 256 per cell -- type 'smc?' to learn how to raise this limit): attempting to terminate..."}︡
︠ed905b52-1a7e-4be0-b425-9c5365c94037s︠
scatter_plot(data)
︡e747a0b7-5861-476a-9c95-825a8d064c59︡{"file":{"filename":"/projects/de7f7a97-3fb3-40ae-af3c-aa8d25cee479/.sage/temp/compute8-us/11390/tmp_N4XRRp.svg","show":true,"text":null,"uuid":"e7d62c84-64b3-4c52-8f13-fb12f54a63bd"},"once":false}︡{"done":true}︡
︠ea4b2275-9cd9-4b11-bbd2-39e9505d4d0es︠
%lisp
(+ 5 (- 9 3))
︡e6539598-578f-4ddd-85ef-862525f9bc30︡{"stdout":"11"}︡{"done":true}︡
︠614d0804-c611-4764-9f91-e91b68216ea5s︠
#n is the number of students
#experiments is the number of experiments performed
def birthday_test2(n, experiments):
    successes = 0
    for i in [1..experiments]:
        birthdays = [randint(1,365) for i in [1..n]]
        if len(Set(birthdays)) < len(birthdays):
            successes = successes + 1
    return successes/experiments
︡bbe59a53-6701-41ea-bc82-20ddfef89382︡{"done":true}︡
︠55c57eb9-294d-40f2-8208-1a1ef81de35as︠
#what is the probability that some pair of 10 students have the same birthday?
#n is the number of students
#experiments is the number of experiments performed
birthday_test2(10, 1000)
︡068740dd-dc78-4985-b0a8-80f0f54b160c︡{"stdout":"121/1000"}︡{"stdout":"\n"}︡{"done":true}︡
︠793f2447-17c4-490f-98d6-5a9d982963b8s︠
birthday_test2(10, 1)
︡f49ef53b-a25d-433c-ae57-1e5a1f51d999︡{"stdout":"0\n"}︡{"done":true}︡
︠253fa664-e2b6-4c9b-90b7-96df1e4a7698s︠
data = [(x,birthday_test2(10,x)) for x in [1..100]]
︡0366c9fe-753c-4b86-9890-4e6130f7dde8︡{"done":true}︡
︠cdeecc4b-a02f-4311-9f16-eafb1b827b56s︠
scatter_plot(data)
︡22fa9a0c-29d2-4069-80d9-494f31c43f24︡{"file":{"filename":"/projects/de7f7a97-3fb3-40ae-af3c-aa8d25cee479/.sage/temp/compute8-us/29330/tmp_v_hbgT.svg","show":true,"text":null,"uuid":"0754f7b4-4b6c-4b60-94ab-b1eac9854666"},"once":false}︡{"done":true}︡
︠c8fe7b25-8714-471f-8b97-8aeaf9e64ec9s︠
data = [(x,birthday_test2(10,x)) for x in [1..1000]]
︡cfc8e0ae-6ea7-481f-81bc-f7204323d3e8︡{"done":true}︡
︠79b73d8c-ca99-456d-bdee-67a715d0c385s︠
scatter_plot(data)
︡633d450a-b95e-48e9-97d9-80ad1e89443d︡{"file":{"filename":"/projects/de7f7a97-3fb3-40ae-af3c-aa8d25cee479/.sage/temp/compute8-us/29330/tmp_ammOrt.svg","show":true,"text":null,"uuid":"acd0e541-5c67-4195-bfc7-bfe1b58476ac"},"once":false}︡{"done":true}︡
︠e337fa79-5380-46d3-86fb-f0652722dba5s︠
birthday_test2(10, 100000)
︡c4e3c1f3-7435-4cdd-bd9c-af11593062c6︡{"stdout":"367/3125"}︡{"stdout":"\n"}︡{"done":true}︡
︠3bd76854-c14f-449b-a8b2-d132ea2c29f5s︠
n(_)
︡12c7e8c9-8b1c-4f11-9d8a-e8cea821b3f3︡{"stdout":"0.117440000000000\n"}︡{"done":true}︡
︠8c10854d-d719-4017-8565-89283f515c0a︠
#n is the number of students
#experiments is the number of experiments performed
#len(Set(birthdays)) < len(birthdays)-1 means *either* 3 students have the same birthday or 2 different pairs of students share the same birthday
def birthday_test3(n, experiments):
    successes = 0
    for i in [1..experiments]:
        birthdays = [randint(1,365) for i in [1..n]]
        if len(Set(birthdays)) < len(birthdays)-1:
            successes = successes + 1
    return successes/experiments
︡8aa9cea0-f9ec-421d-9393-e847649c442f︡{"done":true}︡
︠3fc936c3-b20e-43e4-b202-d19d29ec44aas︠
data = []
for i in [1..365]:
    result = birthday_test3(i,100)
    print i, result.n()

    data.append((i,result))
︡26b25aa6-220e-4893-8467-3530cc5b6b18︡{"stdout":"1 0.000000000000000\n2 0.000000000000000\n3 0.000000000000000\n4 0.000000000000000\n5 0.000000000000000\n6 0.000000000000000\n7"}︡{"stdout":" 0.0100000000000000\n8 0.000000000000000\n9 0.000000000000000\n10 0.000000000000000\n11 0.0300000000000000\n12 0.000000000000000\n13 0.0100000000000000\n14"}︡{"stdout":" 0.0200000000000000\n15 0.0300000000000000\n16 0.0400000000000000\n17 0.0400000000000000\n18 0.110000000000000\n19"}︡{"stdout":" 0.130000000000000\n20 0.0800000000000000\n21 0.0900000000000000\n22 0.170000000000000\n23 0.100000000000000\n24"}︡{"stdout":" 0.140000000000000\n25 0.210000000000000\n26 0.250000000000000\n27 0.210000000000000\n28"}︡{"stdout":" 0.290000000000000\n29 0.380000000000000\n30 0.370000000000000\n31 0.310000000000000\n32"}︡{"stdout":" 0.400000000000000\n33 0.350000000000000\n34 0.410000000000000\n35 0.480000000000000\n36"}︡{"stdout":" 0.500000000000000\n37 0.600000000000000\n38 0.520000000000000\n39 0.570000000000000\n40"}︡{"stdout":" 0.600000000000000\n41 0.630000000000000\n42 0.700000000000000\n43"}︡{"stdout":" 0.680000000000000\n44 0.750000000000000\n45 0.780000000000000\n46 0.780000000000000\n47"}︡{"stdout":" 0.820000000000000\n48 0.840000000000000\n49 0.780000000000000\n50"}︡{"stdout":" 0.830000000000000\n51 0.810000000000000\n52 0.950000000000000\n53"}︡{"stdout":" 0.890000000000000\n54 0.900000000000000\n55 0.900000000000000\n56"}︡{"stdout":" 0.950000000000000\n57 0.940000000000000\n58 0.970000000000000\n59"}︡{"stdout":" 0.990000000000000\n60 0.980000000000000\n61 0.970000000000000\n62"}︡{"stdout":" 0.930000000000000\n63 0.970000000000000\n64 0.970000000000000\n65"}︡{"stdout":" 0.980000000000000\n66 0.970000000000000\n67 0.990000000000000\n68"}︡{"stdout":" 1.00000000000000\n69 1.00000000000000\n70 1.00000000000000\n71"}︡{"stdout":" 1.00000000000000\n72 0.990000000000000\n73 1.00000000000000\n74"}︡{"stdout":" 1.00000000000000\n75 0.990000000000000\n76"}︡{"stdout":" 1.00000000000000\n77 1.00000000000000\n78 1.00000000000000\n79"}︡{"stdout":" 1.00000000000000\n80 1.00000000000000\n81 1.00000000000000\n82"}︡{"stdout":" 1.00000000000000\n83 1.00000000000000\n84 1.00000000000000\n85"}︡{"stdout":" 1.00000000000000\n86 1.00000000000000\n87"}︡{"stdout":" 1.00000000000000\n88 1.00000000000000\n89"}︡{"stdout":" 1.00000000000000\n90 1.00000000000000\n91"}︡{"stdout":" 1.00000000000000\n92 1.00000000000000\n93"}︡{"stdout":" 1.00000000000000\n94 1.00000000000000\n95"}︡{"stdout":" 1.00000000000000\n96 1.00000000000000\n97 1.00000000000000\n98"}︡{"stdout":" 1.00000000000000\n99 1.00000000000000\n100"}︡{"stdout":" 1.00000000000000\n101 1.00000000000000\n102"}︡{"stdout":" 1.00000000000000\n103 1.00000000000000\n104"}︡{"stdout":" 1.00000000000000\n105 1.00000000000000\n106"}︡{"stdout":" 1.00000000000000\n107 1.00000000000000\n108"}︡{"stdout":" 1.00000000000000\n109 1.00000000000000\n110"}︡{"stdout":" 1.00000000000000\n111 1.00000000000000\n112"}︡{"stdout":" 1.00000000000000\n113 1.00000000000000\n114"}︡{"stdout":" 1.00000000000000\n115 1.00000000000000\n116"}︡{"stdout":" 1.00000000000000\n117 1.00000000000000\n118"}︡{"stdout":" 1.00000000000000\n119 1.00000000000000\n120"}︡{"stdout":" 1.00000000000000\n121 1.00000000000000\n122"}︡{"stdout":" 1.00000000000000\n123 1.00000000000000\n124"}︡{"stdout":" 1.00000000000000\n125 1.00000000000000\n126"}︡{"stdout":" 1.00000000000000\n127 1.00000000000000\n128"}︡{"stdout":" 1.00000000000000\n129 1.00000000000000\n130"}︡{"stdout":" 1.00000000000000\n131 1.00000000000000\n132"}︡{"stdout":" 1.00000000000000\n133 1.00000000000000\n134"}︡{"stdout":" 1.00000000000000\n135 1.00000000000000\n136"}︡{"stdout":" 1.00000000000000\n137 1.00000000000000\n138"}︡{"stdout":" 1.00000000000000\n139 1.00000000000000\n140"}︡{"stdout":" 1.00000000000000\n141 1.00000000000000\n142"}︡{"stdout":" 1.00000000000000\n143 1.00000000000000\n144"}︡{"stdout":" 1.00000000000000\n145 1.00000000000000\n146"}︡{"stdout":" 1.00000000000000\n147 1.00000000000000\n148"}︡{"stdout":" 1.00000000000000\n149 1.00000000000000\n150"}︡{"stdout":" 1.00000000000000\n151 1.00000000000000\n152"}︡{"stdout":" 1.00000000000000\n153 1.00000000000000\n154"}︡{"stdout":" 1.00000000000000\n155 1.00000000000000\n156"}︡{"stdout":" 1.00000000000000\n157 1.00000000000000\n158"}︡{"stdout":" 1.00000000000000\n159 1.00000000000000\n160"}︡{"stdout":" 1.00000000000000\n161 1.00000000000000\n162"}︡{"stdout":" 1.00000000000000\n163 1.00000000000000\n164"}︡{"stdout":" 1.00000000000000\n165 1.00000000000000\n166"}︡{"stdout":" 1.00000000000000\n167"}︡{"stdout":" 1.00000000000000\n168 1.00000000000000\n169"}︡{"stdout":" 1.00000000000000\n170 "}︡{"stdout":"1.00000000000000\n171 1.00000000000000\n172"}︡{"stdout":" 1.00000000000000\n173"}︡{"stdout":" 1.00000000000000\n174"}︡{"stdout":" 1.00000000000000\n175 1.00000000000000\n176"}︡{"stdout":" 1.00000000000000\n177 1.00000000000000\n178"}︡{"stdout":" 1.00000000000000\n179 1.00000000000000\n180"}︡{"stdout":" 1.00000000000000\n181 "}︡{"stdout":"1.00000000000000\n182 1.00000000000000\n183"}︡{"stdout":" 1.00000000000000\n184 1.00000000000000\n185"}︡{"stdout":" 1.00000000000000\n186 1.00000000000000\n187"}︡{"stdout":" 1.00000000000000\n188 1.00000000000000\n189"}︡{"stdout":" 1.00000000000000\n190 1.00000000000000\n191"}︡{"stdout":" 1.00000000000000\n192 1.00000000000000\n193"}︡{"stdout":" 1.00000000000000\n194 1.00000000000000\n195"}︡{"stdout":" 1.00000000000000\n196 1.00000000000000\n197"}︡{"stdout":" 1.00000000000000\n198 1.00000000000000\n199"}︡{"stdout":" 1.00000000000000\n200 1.00000000000000\n201"}︡{"stdout":" 1.00000000000000\n202"}︡{"stdout":" 1.00000000000000\n203 1.00000000000000\n204"}︡{"stdout":" 1.00000000000000\n205 1.00000000000000\n206"}︡{"stdout":" 1.00000000000000\n207 1.00000000000000\n208"}︡{"stdout":" 1.00000000000000\n209 1.00000000000000\n210"}︡{"stdout":" 1.00000000000000\n211 1.00000000000000\n212"}︡{"stdout":" 1.00000000000000\n213 1.00000000000000\n214"}︡{"stdout":" 1.00000000000000\n215 1.00000000000000\n216"}︡{"stdout":" 1.00000000000000\n217"}︡{"stdout":" 1.00000000000000\n218 1.00000000000000\n219"}︡{"stdout":" 1.00000000000000\n220"}︡{"stdout":" 1.00000000000000\n221"}︡{"stdout":" 1.00000000000000\n222"}︡{"stdout":" 1.00000000000000\n223 1.00000000000000\n224"}︡{"stdout":" 1.00000000000000\n225"}︡{"stdout":" 1.00000000000000\n226"}︡{"stdout":" 1.00000000000000\n227"}︡{"stdout":" 1.00000000000000\n228"}︡{"stdout":" 1.00000000000000\n229"}︡{"stdout":" 1.00000000000000\n230"}︡{"stdout":" 1.00000000000000\n231 1.00000000000000\n232"}︡{"stdout":" 1.00000000000000\n233"}︡{"stdout":" 1.00000000000000\n234"}︡{"stdout":" 1.00000000000000\n235"}︡{"stdout":" 1.00000000000000\n236"}︡{"stdout":" 1.00000000000000\n237"}︡{"stdout":" 1.00000000000000\n238 1.00000000000000\n239"}︡{"stdout":" 1.00000000000000\n240"}︡{"stdout":" 1.00000000000000\n241 1.00000000000000\n"}︡{"stdout":"242 1.00000000000000\n243"}︡{"stdout":" 1.00000000000000\n244"}︡{"stdout":" 1.00000000000000\n245"}︡{"stdout":" 1.00000000000000\n246 1.00000000000000\n247"}︡{"stdout":" 1.00000000000000\n248"}︡{"stdout":" 1.00000000000000\n249"}︡{"stdout":" 1.00000000000000\n250"}︡{"stdout":" 1.00000000000000\n251"}︡{"stdout":" 1.00000000000000\n252"}︡{"stdout":" 1.00000000000000\n253"}︡{"stdout":" 1.00000000000000\n254"}︡{"stdout":" 1.00000000000000\n255"}︡{"stdout":" 1.00000000000000\n256"}︡{"stdout":" 1.00000000000000\n257"}︡{"stdout":" 1.00000000000000\n258"}︡{"stdout":" 1.00000000000000\n259"}︡{"stdout":" 1.00000000000000\n260"}︡{"stdout":" 1.00000000000000\n261"}︡{"stdout":" 1.00000000000000\n262"}︡{"stdout":" 1.00000000000000\n263"}︡{"stdout":" 1.00000000000000\n264"}︡{"stdout":" 1.00000000000000\n265"}︡{"stdout":" 1.00000000000000\n266"}︡{"stdout":" 1.00000000000000\n267"}︡{"stdout":" 1.00000000000000\n268"}︡{"stdout":" 1.00000000000000\n269"}︡{"stdout":" 1.00000000000000\n270"}︡{"stdout":" 1.00000000000000\n271"}︡{"stdout":" 1.00000000000000\n272"}︡{"stdout":" 1.00000000000000\n273"}︡{"stdout":" 1.00000000000000\n274"}︡{"stdout":" 1.00000000000000\n275"}︡{"stdout":" 1.00000000000000\n276"}︡{"stdout":" 1.00000000000000\n277"}︡{"stdout":" 1.00000000000000\n278"}︡{"stdout":" 1.00000000000000\n279"}︡{"stdout":" 1.00000000000000\n280"}︡{"stdout":" 1.00000000000000\n281"}︡{"stdout":" 1.00000000000000\n282"}︡{"stdout":" 1.00000000000000\n283"}︡{"stdout":" 1.00000000000000\n284"}︡{"stdout":" 1.00000000000000\n285"}︡{"stdout":" 1.00000000000000\n286"}︡{"stdout":" 1.00000000000000\n287"}︡{"stdout":" 1.00000000000000\n288"}︡{"stdout":" 1.00000000000000\n289"}︡{"stdout":" 1.00000000000000\n290"}︡{"stdout":" 1.00000000000000\n291"}︡{"stdout":" 1.00000000000000\n292"}︡{"stdout":" 1.00000000000000\n293"}︡{"stdout":" 1.00000000000000\n294"}︡{"stdout":" 1.00000000000000\n295"}︡{"stdout":" 1.00000000000000\n296"}︡{"stdout":" 1.00000000000000\n297"}︡{"stdout":" 1.00000000000000\n298"}︡{"stdout":" 1.00000000000000\n299"}︡{"stdout":" 1.00000000000000\n300"}︡{"stdout":" 1.00000000000000\n301"}︡{"stdout":" 1.00000000000000\n302"}︡{"stdout":" 1.00000000000000\n303"}︡{"stdout":" 1.00000000000000\n304"}︡{"stdout":" 1.00000000000000\n305"}︡{"stdout":" 1.00000000000000\n306"}︡{"stdout":" 1.00000000000000\n307"}︡{"stdout":" 1.00000000000000\n308"}︡{"stdout":" 1.00000000000000\n309"}︡{"stdout":" 1.00000000000000\n310"}︡{"stdout":" 1.00000000000000\n311"}︡{"stdout":" 1.00000000000000\n312"}︡{"stdout":" 1.00000000000000\n313"}︡{"stdout":" 1.00000000000000\n314"}︡{"stdout":" 1.00000000000000\n315"}︡{"stdout":" 1.00000000000000\n316"}︡{"stdout":" 1.00000000000000\n317"}︡{"stdout":" 1.00000000000000\n318"}︡{"stdout":" 1.00000000000000\n319"}︡{"stdout":" 1.00000000000000\n320"}︡{"stdout":" 1.00000000000000\n321"}︡{"stdout":" 1.00000000000000\n322"}︡{"stdout":" 1.00000000000000\n323"}︡{"stdout":" 1.00000000000000\n324"}︡{"stdout":" 1.00000000000000\n325"}︡{"stdout":" 1.00000000000000\n326"}︡{"stdout":" 1.00000000000000\n327"}︡{"stdout":" 1.00000000000000\n328"}︡{"stdout":" 1.00000000000000\n329"}︡{"stdout":" 1.00000000000000\n330"}︡{"stdout":" 1.00000000000000\n331"}︡{"stdout":" 1.00000000000000\n332"}︡{"stdout":" 1.00000000000000\n333"}︡{"stdout":" 1.00000000000000\n334"}︡{"stdout":" 1.00000000000000\n335"}︡{"stdout":" 1.00000000000000\n336"}︡{"stdout":" 1.00000000000000\n337"}︡{"stdout":" 1.00000000000000\n338"}︡{"stdout":" 1.00000000000000\n339"}︡{"stdout":" 1.00000000000000\n340"}︡{"stdout":" 1.00000000000000\n341"}︡{"stdout":" 1.00000000000000\n342"}︡{"stdout":" 1.00000000000000\n343"}︡{"stdout":" 1.00000000000000\n344"}︡{"stdout":" 1.00000000000000\n345"}︡{"stdout":" 1.00000000000000\n346"}︡{"stdout":" 1.00000000000000\n347"}︡{"stdout":" 1.00000000000000\n348"}︡{"stdout":" 1.00000000000000\n349"}︡{"stdout":" 1.00000000000000\n350"}︡{"stdout":" 1.00000000000000\n351"}︡{"stdout":" 1.00000000000000\n352"}︡{"stdout":" 1.00000000000000\n353"}︡{"stdout":" 1.00000000000000\n354"}︡{"stdout":" 1.00000000000000\n355"}︡{"stdout":" 1.00000000000000\n356"}︡{"stdout":" 1.00000000000000\n357"}︡{"stdout":" 1.00000000000000\n358"}︡{"stdout":" 1.00000000000000\n359"}︡{"stdout":" 1.00000000000000\n360"}︡{"stdout":" 1.00000000000000\n361"}︡{"stdout":" 1.00000000000000\n362"}︡{"stdout":" 1.00000000000000\n363"}︡{"stdout":" 1.00000000000000\n364"}︡{"stdout":" 1.00000000000000\n365"}︡{"stdout":" 1.00000000000000\n"}︡{"done":true}︡
︠205610f1-5661-42ce-a1ce-83fce7aa171b︠









